(kuangbin带你飞--简单搜索)Prime Path POJ3126

原题目:

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input:

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output:
One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input:

3

1033 8179

1373 8017

1033 1033

Sample Output:

6 7 0

大概中文翻译:给你两个素数,并且告诉你一种素数变素数的方法,一个素数只变一个数字并且这个数还是素数的的话计变化一次,问最少变化多少次能从给你的第一个素数变到给你的第二个素数。

#include<iostream>
#include<stdio.h>
#include<algorithm>
#include<vector>
#include<queue>
#include<string.h>
#include<fstream>
#include<math.h>
#define mod 1000000007
#define INF 0x3f3f3f3f
using namespace std;
int n,prime1,prime2;
struct N
{
	int sign;//变换到指定素数需要变换多少次 
	int num[4];
};
queue<N> que; 
bool isprim[10005];
bool vis[10005];
void is_prim()//判断该数是否是素数 //开方求素数方法 
{
	for(int i=1000;i<=9999;i++) 
	{
		bool r=true;
		for(int j=2;j<sqrt((double)i)+1;j++)
		{
			if(i%j==0)
			{
				r=false;
				break;
			}
			
		}
		if(r==true)
			{
				isprim[i]=true;
			}
	}
}
int getnum(int *n)//将原先存为数组的数再变回来 
{
	return n[0]*1000+n[1]*100+n[2]*10+n[3];
}
int bfs()
{
	int ans=0;
	while(!que.empty())
	{
		N cnt=que.front();
		que.pop();
		int cntnum=getnum(cnt.num);
		vis[cntnum]=true;
		if(cntnum==prime2)
		{
			ans=cnt.sign;
			break; 
		}
		cnt.sign++;
		for(int k=0;k<4;k++)
		{
			int cc=cnt.num[k];
			for(int i=0;i<10;i++)
			{
				cnt.num[k]=i;
				int newnum=getnum(cnt.num);//生成新的数,并筛选出素数 
				if(vis[newnum]==0&&isprim[newnum])
				{
					que.push(cnt);//将新生成的素数压入队列中 
				}
			}
			cnt.num[k]=cc;//不明白这步骤的目的 
		}
		
	}
	while(!que.empty())
	{
		que.pop();
	 } 
	 return ans;
}
int main()
{
	is_prim();
	int t;
	scanf("%d",&t);
	while(t--)
	{
		memset(vis,0,sizeof(vis));
		scanf("%d%d",&prime1,&prime2);
	    N b;	
		for(int i=3;i>=0;i--)
		{
			b.num[i]=prime1%10;
			prime1/=10;
		}
		b.sign=0;
		que.push(b);
		int ans=bfs();
		printf("%d\n",ans);
	}
	return 0;
}

思路:

利用广搜,直接从素数里面寻找,将四位数变成num[4]来进行储存并且在需要进行判断是否到达目标的时候再进行转换变回原先的数据,

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

deebcjrb

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值